//----------------------------------------------------------------------------
// ECCrypt.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: ECCrypt.pas
//----------------------------------------------------------------------------
#ifndef ECCryptHPP
#define ECCryptHPP
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <System.hpp>
namespace Eccrypt
{
//-- type declarations -------------------------------------------------------
typedef Byte TDigest[20];

enum TMode { Base64, Hex };

class __declspec(delphiclass) TEllipticCurve;
class __declspec(pascalimplementation) TEllipticCurve : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	TMode FMode;
	System::AnsiString FPassPhrase;
	bool FValid;
	System::AnsiString FPublicKey;
	System::AnsiString FSecretKey;
	System::AnsiString FSessionKey;
	System::AnsiString FExchangedValue;
	System::AnsiString FSignature;
	void __fastcall Clear(void);
	void __fastcall NagRegister(void);
	
public:
	void __fastcall MakeKey(void);
	void __fastcall Encrypt(void);
	void __fastcall Decrypt(void);
	void __fastcall Sign(const Byte * Digest);
	void __fastcall Verify(const Byte * Digest);
	System::AnsiString __fastcall GetVersion(void);
	
__published:
	__property TMode IOMode = {read=FMode, write=FMode, nodefault};
	__property System::AnsiString PassPhrase = {read=FPassPhrase, write=FPassPhrase, nodefault};
	__property bool Valid = {read=FValid, write=FValid, nodefault};
	__property System::AnsiString KeyPublic = {read=FPublicKey, write=FPublicKey, nodefault};
	__property System::AnsiString KeySecret = {read=FSecretKey, write=FSecretKey, nodefault};
	__property System::AnsiString KeySession = {read=FSessionKey, write=FSessionKey, nodefault};
	__property System::AnsiString ExchangedValue = {read=FExchangedValue, write=FExchangedValue, nodefault
		};
	__property System::AnsiString Signature = {read=FSignature, write=FSignature, nodefault};
public:
	/* TComponent.Create */ __fastcall virtual TEllipticCurve(Classes::TComponent* AOwner) : Classes::TComponent(
		AOwner) { }
	/* TComponent.Destroy */ __fastcall virtual ~TEllipticCurve(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);
extern int __fastcall GetExpt(int index);
extern int __fastcall GetLogt(int index);
extern void __fastcall InitTables(void);

}	/* namespace Eccrypt */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Eccrypt;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// ECCrypt
